// Copyright 2019 Lipeng Zha, Inc. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "Styling/SlateStyle.h"

class FVersionUpdaterStyle
{
public:

	static void Initialize(const FString& Name);

	static void Shutdown();

	/** reloads textures used by slate renderer */
	static void ReloadTextures();

	/** @return The Slate style set for the Shooter game */
	static const ISlateStyle& Get();

	static FName GetStyleSetName();

	static const FSlateBrush* GetBrush( FName PropertyName, const ANSICHAR* Specifier = NULL );
private:

	static TSharedRef< class FSlateStyleSet > Create(const FString& Name);

private:

	static TSharedPtr< class FSlateStyleSet > StyleInstance;
};